 /*******************************************************************************

    VOLTIMETRO DIGITAL 0 A +50 VOLTS  (DELTA-SIGMA)
    
    (VERSO 7 SEGUIMENTOS NODO COMUM)

    AUTOR: CLAUDIO LRIOS

    DATA: 09/11/2022

    COM  AT89C2051

    OBS. MONTAGEM  DE NATUREZA DIDTICA
    USE COMPILADOR MIKROC FOR 8051 V.3.6.0

    ESTE ARQUIVO  PARTE INTEGRANTE DO BLOG PICSOURCE
*******************************************************************************/
//BIT

sbit   a2    at  P1.B3; //nodo do display das dezenas
sbit   a1    at  P1.B4; //nodo do display das unidades
sbit   a0    at  P1.B5; //nodo do display dos dcimos de volts
sbit   m_out at  P1.B2; //sada do modulador de 1 bit
sbit   cout  at  P3.B6; //sada do comparador interno

char un,dez,cent,vez,c,d,una,tap;
unsigned int res,ciclo;
unsigned long v1,v2;

 #define VALOR_TENSAO_REAL_VCC 49600000   //4,96VOLTS NO VCC
 #define RESOLUTION  4096


const char num[]= {
       0b11000000, //0  0xc0
       0b11111001, //1  0xf9
       0b01100100, //2  0x64
       0b01110000, //3  0x70
       0b01011001, //4  0x59
       0b01010010, //5  0x52
       0b01000010, //6  0x42
       0b11111000, //7  0xf8
       0b01000000, //8  0x40
       0b01010000, //9  0x50

};
void multiplexa(){
    a2=1;
    a1=1;
    a0=1;
    if(++vez>2)vez=0;
    if(vez==0){P3=un; a0=0;}    //mostra unidades
    if(vez==1){P3=dez; a1=0;}   //mostra dezenas
    if(vez==2){P3=cent; a2=0;}  //mostra centenas
}
void mpx(){
char a;
    for(a=0;a<4;a++){
      multiplexa();
      //delay_ms(1);
      TF0_bit==0;
      while(TF0_BIT==0);
    }
   // a2=1;  //apaga seguimentos pelos nodos
   // a1=1;
  //  a0=1;
}


void le_tensao(){
     res=0; //limpa resultados da converso
     ciclo=0;
     TH0=173;
     TL0=173;
     TMOD=0b00000010 ;//timer 0 no modo 2 contando tempo com recarga automtica
     TCON=0b00010000 ;//desliga timer 1 liga timer 0

     ciclo=0;
     do{

       TF0_bit=0; //apaga flag do timer 0
       if(cout)m_out=1;//seta modulador
       else{
         m_out=0;
         res++;//incrementa resultado
       }
       multiplexa();
       while(TF0_bit==0);
       ciclo++;
    }while(ciclo<RESOLUTION);   //for 12 bits resolution
    m_out=0;//modulador=0
}
/*************************************************************************
       Rotina Main
*************************************************************************/
void main() {
     P1=0b00111011;  //desliga anodos /p1.0 e p1.1 em '1' para funcionar comparador
     P3=0x00;  //desliga
     vez=0;
     una=0;
     d=0;
 /*************************************************************************
       Lao Infinito
*************************************************************************/

  for(;;){

    le_tensao();

     v1=VALOR_TENSAO_REAL_VCC/RESOLUTION; //12 bits de resoluo
     v1= v1 * res;

     /*
     cent= v1 / 10000000;
     v1= v1 % 10000000;
     dez= v1 / 1000000;
     v1= v1 % 1000000;
     un= v1 / 100000;
     */
     
     cent=0;
     while(v1>=10000000){v1=v1-10000000; cent++;}
     dez=0;
     while(v1>=1000000){v1=v1-1000000; dez++;}
     un=0;
     while(v1>=100000){v1=v1-100000; un++;}
     

     cent=num[cent];  //converte para 7 seguimentos
     dez=num[dez];
     un=num[un];
     if(cent==0xc0)cent=0xff;//apaga zero a esquerda



 }//for(;;)
}  //main()